#include <stdio.h>
#include "Image.h"

short Image::load(char *fname)
{
  FILE *fp;
  int tmp,i,sz;
  unsigned maxVal;
	char comment[1024];

  if((fp=fopen(fname,"rb"))==NULL)
    return(0);

  fscanf(fp,"P%d\n",&tmp);
	if(tmp!=5)       //not PGM raw file
		return(0);

	while(fscanf(fp,"#%[^\n]\n",comment) > 0);

  fscanf(fp,"%u%u\n", &width, &height);
  fscanf(fp,"%u%*c", &maxVal);

  if(data != NULL)
    delete [] data;
	sz = width*height;
  data = new float[sz];

	unsigned char *tmpData = new unsigned char[sz];
  fread(tmpData,sizeof(unsigned char),sz,fp);
	for(i=0; i<sz; i++)
		data[i] = tmpData[i];
	delete tmpData;

	return(1);
}
/*****************************************************************/
void Image::saveMatlab(char *fname)
{
  FILE *fp = fopen(fname,"w");
  
  
  for(int y=0; y<height; y++) {
    for(int x=0; x<width; x++) {
      fprintf(fp,"%f ",Pix(x,y));
    }
    fprintf(fp,"\n");
  }
  fclose(fp);
}
/*****************************************************************/
void Image::saveViewablePnm(char *fname)
{
            //normalize data to be in [0,255] 
  float max,min;
  int i, imgSize = size();

  max = min = data[0];
  for(i=0; i<imgSize; i++) {
    if(data[i]>max)
      max = data[i];
    else if(data[i]<min)
      min = data[i];
  }
  short *normalizedData = new short[imgSize];
  float scaleFactor = 255.0f/(max-min);
  for(i=0; i<imgSize; i++) 
    normalizedData[i] = (short)((data[i] - min) * scaleFactor);
  
  FILE *fp = fopen(fname,"w");

  fprintf(fp,"P2\n");
  fprintf(fp,"%u %u\n", width, height);
  fprintf(fp,"255\n"); 

  for(int y=0; y<height; y++) {
    for(int x=0; x<width; x++) {
      fprintf(fp,"%d ",normalizedData[y*width+x]);
    }
    fprintf(fp,"\n");
  }
  fclose(fp);
}
/*****************************************************************/


